﻿


;-------------------------------------------------------------------------------
Combinations(String, Skip) { ; return an array with the sub-keywords
;-------------------------------------------------------------------------------
    ; sub-keywords are the keywords of all the substrings of String
    ;---------------------------------------------------------------------------
    global Max_Input_Length

    Keyword := make_Keyword(String) ; the only call here to make_Keyword()
    Store := []
    Store[0] := []
    Store[0, Keyword] := True
    Result := [Keyword]

    N := StrLen(String) - 1 - (Skip = Max_Input_Length ? 0 : Skip)
    Loop, % N {
        Store[n := A_Index] := [] ; array of n* shortened strings
        For ShortKey in Store[n - 1] {
            Loop, % StrLen(ShortKey) // 2 + 1 {

                ; split the ShortKey and get next shorter keyword
                Split1 := SubStr(ShortKey, 1, 2 * A_Index - 2)  ; keep delim
                Split3 := SubStr(ShortKey, 2 * A_Index + 1)     ; drop delim
                NextShorter := RTrim(Split1 Split3, ",")        ; trim delim

                If Not Store[n].HasKey(NextShorter) {
                    Store[n, NextShorter] := True
                    Result.Push(NextShorter)
                }
            }
        }
    }

    Return, Result
}



;-------------------------------------------------------------------------------
make_Keyword(String) { ; return a sorted, comma separated string of chars
;-------------------------------------------------------------------------------
    Keyword := LTrim(RegExReplace(String, "(.)", ",$1"), ",")
    Sort, Keyword, D,
    Return, Keyword
}



;-------------------------------------------------------------------------------
LengthSort(a, b) { ; word length specific custom sort
;-------------------------------------------------------------------------------
    ; Compacting this function to a one-liner, similar to the examples
    ; in the help file, runs about 20% faster than before.
    ;---------------------------------------------------------------------------

    ; primary criterion is string length, otherwise sort alphabetically
    Return, StrLen(a) < StrLen(b) ? 1 : StrLen(a) > StrLen(b) ? -1
        : a > b ? 1 : a < b ? -1 : 0
}
